#!/usr/local/bin/perl
#
# PointEdit
#
# How to edit this file:
#
# You need to change the first line to point to your perl installation
#  (i.e. /usr/bin/perl)
#
# $selfurl
#
#    In the Configuration section, you must change the $selfurl variable
#    so that it points to where you have this script located.  
#
# $password
#
#    You should also change the $password variable to a password you choose.
#
# $title and $bodystyle
#
#    If you want a different title or bodystyle for the PointEdit-generated
#    pages, or a different bodystyle, you can change them here.
#
# Other things you may need to do:
#
#    PointEdit needs to have permissions set to 777 (Unix) owner read/write/execute
#    and other read/execute in order to work.  Depending on the system you use,
#    you may need to change the permissions of the files edited by PointEdit to
#    666 (Unix) or owner read/write other read/write.
#
# HTML syntax reference
#
#    on the line BEFORE the one you wish to edit, put the following:
#        <!---PointEdit TYPE={TAG|LINE|AREA|SSI} NAME=helpfulname--->
#
#    example
#        <!-- PointEdit TYPE=TAG NAME=bodytag--->
#        <BODY BGCOLOR="#ffffff">
#
#        <!-- PointEdit TYPE=AREA NAME=area -->
#        Some lines
#        Some more lines
#        <!-- PointEdit TYPE=AREA NAME=area -->
#
# PointEdit use reference
#
#    To start PointEdit, just point your browser to
#        pointedit.cgi 
#
#    and you will see a form with a place to put a path and file name.  When you 
#    enter a filename here and click OK, you will be taken to a script-produced
#    form allowing you to edit the fields in the document.  When you put in a
#    correct password and push the 'Submit' button, pointedit will implement your
#    changes.
#
#    PointEdit is copyright 1998 by Greg Billock, billgr@optics.caltech.edu
#    It is available for free distribution, use at your own risk, under the GNU 
#    Public License (GPL).
#    Do not redistribute without permission.
#    If you have further suggestions for features, or make substantial modifications,
#    please let me know.

######################
#configuration section

$selfurl = "http://www.deltaland.net/cgi-bin/davidedit1.pl";

$password = "riverdelta";

$title = "PointEdit";
$bodystyle = "<BODY BGCOLOR=\"#ffffff\">";

####################
#execution starts

#let the browser know we're coming
&printhtmlhead;

&readparam;   #read in CGI parameters to %cgiVals

# &putenv;

#check if any arguments
if (%cgiVals) {

   $editfile = delete $cgiVals{'edit'};

   if (%cgiVals) {
      &parseedit;
   }
   else {
      &editfileform;	#edit $editfile
   }
}
else {    #input form
   &printfileform;
}

&printhtmlfoot;

#exit script
exit(0);


##record edited changes
sub parseedit {
   $inputpwd = $cgiVals{'password'};
   if ($inputpwd eq $password) {
      #changes are OK'ed by administrator
      open(FILE, "$editfile");
      @filelines = <FILE>;
      close(FILE);

      $inarea = 0;
      $inline = 0;
      $intag = 0;
      $inssi = 0;
     
      open(FILE, ">$editfile");
      foreach (@filelines) {
         chomp($_);
         if (/<!--.*?PointEdit.*?\>/i) {
            print FILE "$_\n";     #output line
            @tokens = split(/ /,$_);
            foreach $token (@tokens) {
               $token =~ s/\-//g;
               $token =~ s/\>//g;
               $token =~ s/\"//g;
               ($var,$val) = split(/=/,uc($token));
               if ($val) {
                   if ($var eq 'TYPE') {
                       $type = $val;
                   }
                   elsif ($var eq 'NAME') {
                       $name = $val;
                   }
               }
            } #endif foreach

            if ($type eq 'LINE') {
               $inline = 1;
            }
            elsif ($type eq 'AREA') {
               if ($inarea == 0) {
                  $inarea = 1;
               }
               else {
                  $inarea = 0;
               }
            }
            elsif ($type eq 'TAG') {
               $intag = 1;
            }
            elsif ($type eq 'SSI') {
               $inssi = 1;
            }

         } #endif (pointedit)
         else {
            if ($inline == 1) {
                $inline = 0;
                $newline = $cgiVals{$name};
                if ($newline) {
                   print FILE "$newline\n";
                }
                else {
                   print FILE "$_\n";
                }
            }
            elsif ($inarea == 1) {
                $newlines = $cgiVals{$name};
                if ($newlines) {
                   chomp($newlines);
                   print FILE "$newlines\n";
                   $inarea = 2;
                }
                else {
                   print FILE "$_\n";
                }
            }
            elsif ($inarea == 2) {
            }
            elsif ($intag == 1) {
                $intag = 0;
                $_ =~ s/\"//g;
                $_ =~ s/\>//g;
                $_ =~ s/\<//g;
                @tagtokens = split(/ /,$_);
                print FILE "<";
                foreach $tagtoken (@tagtokens) {
                    ($tagvar,$tagval) = split(/=/,$tagtoken);
                    if ($tagval) {
                        $tagvar = uc($tagvar);
                        $newtag = $cgiVals{"$name\_$tagvar"};
                        if ($newtag) {
                            print FILE "$tagvar=\"$newtag\" ";
                        }
                        else {
                            print FILE "$tagvar=\"$tagval\" ";
                        }
                    }
                    else {
                        print FILE "$tagtoken ";
                    }
                } #end foreach
                print FILE ">\n";
            }
            elsif ($inssi == 1) {
                $inssi = 0;
                $_ =~ s/\!//g;
                $_ =~ s/\>//g;
                $_ =~ s/\<//g;
                $_ =~ s/\-//g;
                $_ =~ s/\"//g;
                @ssitokens = split(/ /,$_);
                print FILE "<!--";
                foreach $ssitoken (@ssitokens) {
                    ($ssivar,$ssival) = split(/=/,$ssitoken);
                    if ($ssival) {
                        $ssivar = uc($ssivar);
                        $newval = $cgiVals{"$name\_$ssivar"};
                        if ($newval) {
                            print FILE "$ssivar=\"$newval\" ";
                        }
                        else {
                            print FILE "$ssivar=\"$ssival\" ";
                        }
                    }
                    else {
                        print FILE "$ssitoken ";
                    }
                } #end foreach
                print FILE "-->\n";
            }
            else {
                print FILE "$_\n";
            }

         } #end ifelse on (pointedit)

      } #end foreach on filelines
      close(FILE);

      print "<H3>Changes have been recorded</H3>\n";
      print "To view the altered file, ";
###########################################################
#     hard coded value $fileurl
      $fileurl='http://www.deltaland.net/community/index.html';
      print "<A HREF=\"$fileurl\">click here</A>.\n";
###########################################################
      print "<P><HR>\n";
      &printfileform;
   }
   else {
      print "<H1>Sorry, password incorrect.  No changes made.</H1>\n";
   }
}

#parse and edit the file
sub editfileform {

   $inarea = 0;
   $inline = 0;
   $intag = 0;
   $inssi = 0;

   open(FILE, "$editfile");
   @filelines = <FILE>;
   close(FILE);

   print "\n<TABLE BORDER=\"2\" CELLSPACING=\"2\" CELLPADDING=\"5\">\n";
   print "<FORM ACTION=\"$selfurl\" METHOD=\"POST\">\n\n";

   foreach (@filelines) {
      chomp($_);
      if (/<!-- PointEdit/i) {
         #tokenize
         @tokens = split(/ /,$_);
         foreach $token (@tokens) {
             $token =~ s/\-//g;
             $token =~ s/\>//g;
             $token =~ s/\"//g;
             ($var,$val) = split(/=/,uc($token));
             if ($val) {
                 if ($var eq 'TYPE') {
                     $type = $val;
                 }
                 elsif ($var eq 'NAME') {
                     $name = $val;
                 }
             }
         }
         
         if ($type eq 'LINE') {
             $inline = 1;
             print "<TR><TD>\nEdit line field $name:<BR>\n";
             print "<BLOCKQUOTE>\n<INPUT TYPE=\"test\" SIZE=\"50\" NAME=\"$name\" ";
         }
         elsif ($type eq 'AREA') {
             if ($inarea == 0) {
                $inarea = 1;
                print "<TR><TD>\nEdit area field $name:<BR>\n";
                print "<BLOCKQUOTE>\n<TEXTAREA ROWS=\"10\" COLS=\"60\" NAME=\"$name\">\n";
             }
             else {
                $inarea = 0;
                print "\n</TEXTAREA>\n</BLOCKQUOTE>\n</TD></TR>\n";
           
             }
         }
         elsif ($type eq 'TAG') {
             $intag = 1;
             print "<TR><TD>\nEdit tag field $name:<BR>\n<BLOCKQUOTE>\n";
         }
         elsif ($type eq 'SSI') {
             $inssi = 1;
             print "<TR><TD>\nEdit SSI field $name:<BR>\n<BLOCKQUOTE>\n";
         }
         else {
             print "<TR><TD>Unrecognized PointEdit type $type\n</TD></TR>\n";
         }
      }
      else {
         if ($inline == 1) {
             $inline = 0;
             print "VALUE=\"$_\"><BR>\n</BLOCKQUOTE>\n</TD></TR>\n";
         }
         elsif ($inarea == 1) {
             #chomp($_);
             print "$_";
         }
         elsif ($intag == 1) {
             $intag = 0;
             $_ =~ s/\"//g;
             $_ =~ s/\>//g;
             $_ =~ s/\<//g;
             @tagtokens = split(/ /,$_);
             foreach $tagtoken (@tagtokens) {
                 ($tagvar,$tagval) = split(/=/,$tagtoken);
                 $tagvar = uc($tagvar);
                 if ($tagval) {
                     print "Tag field $tagvar:";
                     print "<INPUT TYPE=\"text\" NAME=\"$name\_$tagvar\" ROWS=\"30\" VALUE=\"$tagval\"><BR>\n";
                 }
             } #end foreach
             print "\n</BLOCKQUOTE>\n</TD></TR>\n";
         }
         elsif ($inssi == 1) {
             $inssi = 0;
             $_ =~ s/\!//g;
             $_ =~ s/\>//g;
             $_ =~ s/\<//g;
             $_ =~ s/\-//g;
             $_ =~ s/\"//g;
             @ssitokens = split(/ /,$_);
             foreach $ssitoken (@ssitokens) {
                 ($ssivar,$ssival) = split(/=/,$ssitoken);
                 if ($ssival) {
                     $ssivar = uc($ssivar);
                     print "Tag field $ssivar:";
                     print "<INPUT TYPE=\"text\" NAME=\"$name\_$ssivar\" ROWS=\"30\" VALUE=\"$ssival\"><BR>\n";
                 }
             } #end foreach
             print "\n</BLOCKQUOTE>\n</TD></TR>\n";
         }
      }
   }  #end foreach

   print "\n<TR><TD><CENTER><INPUT TYPE=\"hidden\" NAME=\"edit\" VALUE=\"$editfile\">\n";
   print "\nEnter password here<BR>\n<INPUT TYPE=\"password\" NAME=\"password\"><P>\n";
   print "<INPUT TYPE=\"submit\" VALUE=\"Submit\"></CENTER>\n</TD></TR>";
   print "\n</FORM>\n</TABLE>\n\n";
}


#print beginning form
sub printfileform {
# preset filename to edit
$edval="/com/deltaland.net/www/community/index.html";
################
   print <<EndOfFileform;
<H3>Deltaland Community Page file editing</H3>
<P>
<HR>
<P>
<FORM ACTION="$selfurl" METHOD="POST">
<!--Please enter the path + filename of the file you wish to edit:-->
<BR>
<INPUT TYPE="hidden" SIZE="50" NAME="edit" VALUE=$edval>
<P>
<INPUT TYPE="submit" VALUE="Edit Announcements">
</FORM>

EndOfFileform
;

}


#prints HTML header
sub printhtmlhead {

   print("Content-type: text/html\n\n");
   print <<EndOfHTML;
<HTML><HEAD><TITLE>$title</TITLE></HEAD>
$bodystyle
EndOfHTML
;

}

#print HTML footer
sub printhtmlfoot {

  print("</BODY></HTML>\n");
}

# read parameters
# name/value pairs are in %cgiVals (global) hash
sub readparam {

  if ( ($ENV{'REQUEST_METHOD'} eq 'POST') || ($ENV{'REQUEST_METHOD'} eq 'post') ) {
    read(STDIN, $buffer, $ENV{'CONTENT_LENGTH'});          #read for POST method to $buffer
    @cgiPairs = split(/\&/,$buffer);
  }
  else {
    #get the pairs of parameters passed to the script      for GET method
    @cgiPairs = split(/\&/,$ENV{'QUERY_STRING'}); 
  }

  #split the pairs into a %cgiVals hash
  foreach $pair ( @cgiPairs ) {
       ($var,$val) = split("=",$pair);
       $val =~ s/\+/ /g;
       $val =~ s/%(..)/pack("c",hex($1))/ge;
       $cgiVals{"$var"} = "$val";
  }
}

#note!  for textarea fields, add this:
#  $FORM{'comments'} =~ s/\r/\n/;
#
#which replaces the linefeeds with the \n newline

sub putenv {

   foreach $key (keys(%ENV)) {
      print "$key = $ENV{$key}<BR>\n";
   }
}


